Index: other-projects/gti/gti-xml-to-spreadsheet.xsl
===================================================================
--- other-projects/gti/gti-xml-to-spreadsheet.xsl	(revision 25287)
+++ other-projects/gti/gti-xml-to-spreadsheet.xsl	(revision 25288)
@@ -8,5 +8,5 @@
        GS2/bin/script> perl -S gti.pl get-first-n-chunks-requiring-work mi coredm 1000 > ../../macros/maori/mi-core.xml
 
-       2. Apply this XSLT to that XML file to obtain a unicode text file containing comma-separated values (a spreadsheet). 
+       2. Apply this XSLT to that XML file to obtain a unicode text file containing tab-separated values (a spreadsheet). 
        NOTE: Make sure the output is a *.txt file if you wish to open it in Excel without losing the unicode 
        (when opened with .csv extension, the unicode is not preserved).
@@ -14,6 +14,7 @@
        GS2/bin/script> java -cp /research/ak19/gs2-svn/bin/java/ApplyXSLT.jar org.nzdl.gsdl.ApplyXSLT -x ../../macros/maori/mi-core.xml -t ../script/gti-xml-to-spreadsheet.xsl > ../../maori/core-mi-spreadsheet.txt
 
-       3. Translators wishing to read this text file into Excel, need to first open Excel. Then go to File > Open, 
-       and choose to open the unicode .txt file containing the comma-separated values.
+       3. Translators wishing to read this text file into Excel, need to first open Excel. 
+       Then go to File > Open, set the filetypes drop-down to show All Files *.*,
+       and choose to open the unicode .txt file containing the tab-separated values.
 
        - A wizard will appear, allowing users to open this .txt file as a proper spreadsheet.
@@ -22,10 +23,15 @@
        b. in the drop down on the right, select unicode (UTF-8 or UTF-16)
        c. Click next
-       In the second frame of the dialog, select "comma" as the delimiter. Click Finish to open the spreadsheet data.
+       In the second frame of the dialog, select "tab" as the delimiter. Click Finish to open the spreadsheet data.
        
-       4. When translators have finished working on the file, they can save it simply as an Excel spreadsheet .xls file 
-       (File > Save As > Excel 2003 spreadsheet) and mail it back to Greenstone.
-       Translators are advised against saving it as a .txt 2003 Excel spreadsheet, since it doesn't seem to preserve the
-       comma delimiters.
+       4. When translators have finished working on the file, save it as an Excel spreadsheet Unicode .txt file 
+       (through File > Save As > Excel 2003 spreadsheet > choose Unicode .txt in the file types box)
+       and mail this text file back to Greenstone.
+
+       5. The file returned by the translator should first be processed with the new gti-process-google-spreadsheet.pl script:
+       GS2/bin/script>perl -S gti-process-google-spreadsheet.pl ~/Desktop/core-mi-xml2spreadsheet-out.txt > <language>-submission.xml
+
+       Then continue processing as usual
+       > cat <language>-submission.xml | perl -S gti.pl submit-translations <language-code> <module-name> <username>
 
     -->
@@ -34,5 +40,5 @@
 
   <xsl:template match="GTIResponse">
-    <xsl:text>Key&#44;Source&#44;Target</xsl:text><!--column headings-->
+    <xsl:text>Key&#09;Source&#09;Target</xsl:text><!--column headings separated by tabs-->
     <xsl:text>&#10;</xsl:text> <!--newline-->  
     <xsl:apply-templates select="ChunksRequiringUpdating"/>
@@ -55,13 +61,17 @@
   <xsl:template match="Chunk">
     <xsl:value-of select="@key"/>
-    <xsl:text>&#44;</xsl:text>
+    <xsl:text>&#09;</xsl:text>
     <xsl:for-each select="SourceFileText">
       <xsl:variable name="escapedText" select='java:org.nzdl.gsdl.ApplyXSLT.replaceAll(., "\n", "&amp;#10;")'/>
+      <!--<xsl:variable name="tempText2" select="java:org.nzdl.gsdl.ApplyXSLT.replaceAll($tempText1, '&#92;&#34;', '&amp;#34;')"/>--> <!-- escape (backslash-)quote with entity for quote-->
+      <!--<xsl:variable name="escapedText" select='java:org.nzdl.gsdl.ApplyXSLT.replaceAll($tempText1, ",", "&amp;#44;")'/>--> <!--Escape commas in text, as they are not CSV delimiters-->
       <xsl:value-of select='$escapedText' disable-output-escaping="yes"/>
     </xsl:for-each>
     <!--<xsl:value-of select="SourceFileText"/>-->
-    <xsl:text>&#44;</xsl:text>
+    <xsl:text>&#09;</xsl:text>
     <xsl:for-each select="TargetFileText">
       <xsl:variable name="escapedText" select='java:org.nzdl.gsdl.ApplyXSLT.replaceAll(., "\n", "&amp;#10;")'/>
+      <!--<xsl:variable name="tempText2" select="java:org.nzdl.gsdl.ApplyXSLT.replaceAll($tempText1, '&#92;&#34;', '&amp;#34;')"/>--> <!-- escape (backslash-)quote with entity for quote-->
+      <!--<xsl:variable name="escapedText" select='java:org.nzdl.gsdl.ApplyXSLT.replaceAll($tempText1, ",", "&amp;#44;")'/>--> <!--Escape commas in text, as they are not CSV delimiters-->
       <xsl:value-of select='$escapedText' disable-output-escaping="yes"/>
     </xsl:for-each>