Index: /main/trunk/greenstone3/web/interfaces/oran/transform/pages/authen.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/transform/pages/authen.xsl	(revision 25291)
+++ /main/trunk/greenstone3/web/interfaces/oran/transform/pages/authen.xsl	(revision 25292)
@@ -16,14 +16,14 @@
 		<xsl:choose>
 			<xsl:when test="/page/pageResponse/authenticationNode/service/@operation = 'AddUser'">
-				<xsl:text>Add a new user</xsl:text>
+				<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.add_a_new_user_title')"/>
 			</xsl:when>
 			<xsl:when test="/page/pageResponse/authenticationNode/service/@operation = 'Register'">
-				<xsl:text>Register</xsl:text>
+				<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.register')"/>
 			</xsl:when>
 			<xsl:when test="/page/pageResponse/authenticationNode/service/@operation = 'EditUser'">
-				<xsl:text>Edit user</xsl:text>
+				<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.edit_user_information')"/>
 			</xsl:when>
 			<xsl:when test="/page/pageResponse/authenticationNode/service/@operation = 'AccountSettings'">
-				<xsl:text>Account settings</xsl:text>
+				<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.account_settings')"/>
 			</xsl:when>
 			<xsl:otherwise>
@@ -53,6 +53,6 @@
 					<form method="POST" action="{$library_name}/admin/{/page/pageRequest/paramList/param[@name = 's1.authpage']/@value}">
 						<table id="loginTable">
-							<tr><td>Username: </td><td><input type="text" name="username"/></td></tr>
-							<tr><td>Password: </td><td><input type="password" name="password"/></td></tr>
+							<tr><td><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.username')"/>: </td><td><input type="text" name="username"/></td></tr>
+							<tr><td><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.password')"/>: </td><td><input type="password" name="password"/></td></tr>
 							<tr><td><input type="submit" value="Login"/></td><td><xsl:text> </xsl:text></td></tr>
 						</table>
@@ -83,8 +83,8 @@
 									<xsl:choose>
 										<xsl:when test="@status = 'true'">
-											<xsl:text>enabled</xsl:text>
+											<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.enabled')"/>
 										</xsl:when>
 										<xsl:otherwise>
-											<xsl:text>disabled</xsl:text>
+											<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.disabled')"/>
 										</xsl:otherwise>
 									</xsl:choose>
@@ -93,6 +93,31 @@
 								<td><xsl:value-of select="@comment"/></td>
 								<td><xsl:value-of select="@email"/></td>
-								<td><a href="{$library_name}/admin/EditUser?s1.username={@username}"><button>Edit</button></a></td>
-								<td><a href="{$library_name}/admin/PerformDeleteUser?s1.username={@username}"><button>Delete</button></a></td>
+								<td><a href="{$library_name}/admin/EditUser?s1.username={@username}"><button><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.edit')"/></button></a></td>
+								<td>
+									<form method="GET" action="{$library_name}/admin/PerformDeleteUser">
+										<input type="hidden" name="s1.username" value="{@username}"/>
+										<input id="delUser{@username}" type="submit" value="{util:getInterfaceText($interface_name, /page/@lang, 'authen.delete')}"/>
+										<script type="text/javascript">
+											<xsl:text disable-output-escaping="yes">
+											{
+												var username = "</xsl:text><xsl:value-of select="@username"/><xsl:text disable-output-escaping="yes">";
+												var confirmMessage = "</xsl:text><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.delete_warning')"/><xsl:text disable-output-escaping="yes">";
+												var button = $("#delUser" + username);
+												button.click(function()
+												{
+													if(confirm(confirmMessage + username + "?"))
+													{
+														return true;
+													}
+													else
+													{
+														return false;
+													}
+												});
+											}	
+											</xsl:text>
+										</script>
+									</form>
+								</td>
 							</tr>
 						</xsl:for-each>
@@ -124,7 +149,13 @@
 						<table>
 							<tr>
-								<td><xsl:text>Username: </xsl:text></td>
+								<td><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.username')"/><xsl:text>: </xsl:text></td>
 								<td>
 									<input type="text" name="s1.newUsername" value="{/page/pageResponse/authenticationNode/service/userNodeList/userNode/@username}"/>
+								</td>
+							</tr>
+							<tr>
+								<td><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.email')"/><xsl:text>: </xsl:text></td>
+								<td>
+									<input type="text" name="s1.newEmail" value="{/page/pageResponse/authenticationNode/service/userNodeList/userNode/@email}"/>
 								</td>
 							</tr>
@@ -133,7 +164,8 @@
 									<tr>
 										<td id="passwordLabelCell">
-											<button id="changePasswordButton">Change Password...</button>
+											<button id="changePasswordButton"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.change_password')"/>...</button>
 											<script type="text/javascript">
 												<xsl:text disable-output-escaping="yes">
+													var passwordLabelText = "</xsl:text><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.password')"/><xsl:text disable-output-escaping="yes">";
 													var changePasswordButton = document.getElementById("changePasswordButton");
 													changePasswordButton.onclick = function()
@@ -141,5 +173,5 @@
 														changePasswordButton.parentNode.removeChild(changePasswordButton);
 														
-														var passwordLabel = document.createTextNode("Password: ");
+														var passwordLabel = document.createTextNode(passwordLabelText + ": ");
 														document.getElementById("passwordLabelCell").appendChild(passwordLabel);
 														
@@ -159,7 +191,11 @@
 								<xsl:when test="/page/pageResponse/authenticationNode/service/@operation = 'AccountSettings'">
 									<tr>
-										<td><button id="changePasswordButton">Change Password...</button></td>
+										<td><button id="changePasswordButton"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.change_password')"/>...</button></td>
 										<script type="text/javascript">
 											<xsl:text disable-output-escaping="yes">
+												var oldPasswordLabelText = "</xsl:text><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.old_password')"/><xsl:text disable-output-escaping="yes">";
+												var newPasswordLabelText = "</xsl:text><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.new_password')"/><xsl:text disable-output-escaping="yes">";
+												var rtNewPasswordLabelText = "</xsl:text><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.retype_password')"/><xsl:text disable-output-escaping="yes">";
+												
 												var changePasswordButton = document.getElementById("changePasswordButton");
 												changePasswordButton.onclick = function()
@@ -169,10 +205,10 @@
 													var names = ["s1.oldPassword", "s1.newPassword", ""];
 													var ids = ["oldPassword", "passwordOne", "passwordTwo"];
-													var labels = ["Old password: ", "New password: ", "Retype new password: "];
+													var labels = [oldPasswordLabelText, newPasswordLabelText, rtNewPasswordLabelText];
 													var parents = ["oldPassword", "password", "retypePassword"];
 													
 													for(var i = 0; i &lt; names.length; i++)
 													{
-														$("#" + parents[i] + "LabelCell").append(labels[i]);
+														$("#" + parents[i] + "LabelCell").append(labels[i] + ": ");
 														
 														var input = $("&lt;input&gt;");
@@ -201,13 +237,7 @@
 								</xsl:when>
 							</xsl:choose>						
-							<tr>
-								<td><xsl:text>Email address: </xsl:text></td>
-								<td>
-									<input type="text" name="s1.newEmail" value="{/page/pageResponse/authenticationNode/service/userNodeList/userNode/@email}"/>
-								</td>
-							</tr>
 							<xsl:if test="/page/pageResponse/authenticationNode/service/@operation = 'EditUser'">
 								<tr>
-									<td><xsl:text>Groups: </xsl:text></td>
+									<td><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.groups')"/><xsl:text>: </xsl:text></td>
 									<td>
 										<input id="groupsInput" size="50" type="text" name="s1.groups" value="{/page/pageResponse/authenticationNode/service/userNodeList/userNode/@groups}"/>
@@ -221,5 +251,5 @@
 									</td>
 									<td>
-										<button id="addGroupButton">Add Group</button>
+										<button id="addGroupButton"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.add_group')"/></button>
 										<script type="text/javascript">
 											<xsl:text disable-output-escaping="yes">
@@ -248,5 +278,5 @@
 								</tr>
 								<tr>
-									<td><xsl:text>Comment: </xsl:text></td>
+									<td><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.comment')"/><xsl:text>: </xsl:text></td>
 									<td>
 										<textarea name="s1.comment" style="width:100%;"><xsl:value-of select="/page/pageResponse/authenticationNode/service/userNodeList/userNode/@comment"/></textarea>
@@ -254,5 +284,5 @@
 								</tr>
 								<tr>
-									<td><xsl:text>Status: </xsl:text></td>
+									<td><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.status')"/><xsl:text>: </xsl:text></td>
 									<td>
 										<input type="radio" name="s1.status" value="true">
@@ -261,5 +291,5 @@
 											</xsl:if>
 										</input>
-										<xsl:text>Enabled </xsl:text>
+										<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.enabled')"/><xsl:text> </xsl:text>
 										
 										<input type="radio" name="s1.status" value="false">
@@ -268,5 +298,5 @@
 											</xsl:if>
 										</input>
-										<xsl:text>Disabled </xsl:text>
+										<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.disabled')"/><xsl:text> </xsl:text>
 									</td>
 								</tr>
@@ -274,5 +304,5 @@
 							<tr>
 								<td>
-									<input id="submitButton" type="submit" value="Submit"/>
+									<input id="submitButton" type="submit" value="{util:getInterfaceText($interface_name, /page/@lang, 'authen.submit')}"/>
 									<xsl:if test="/page/pageResponse/authenticationNode/service/@operation = 'AccountSettings'">
 										<script type="text/javascript">
@@ -299,5 +329,5 @@
 							</tr>
 							<tr>
-								<td style="font-size:0.6em;"><a href="{$library_name}/admin/PerformResetPassword?s1.username={/page/pageResponse/authenticationNode/service/userNodeList/userNode/@username}"><br/>Reset Password...</a></td>
+								<td style="font-size:0.6em;"><a href="{$library_name}/admin/PerformResetPassword?s1.username={/page/pageResponse/authenticationNode/service/userNodeList/userNode/@username}"><br/><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.reset_password')"/>...</a></td>
 							</tr>
 						</table>
@@ -322,5 +352,5 @@
 						<table>
 							<tr>
-								<td><xsl:text>Username: </xsl:text></td>
+								<td><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.username')"/><xsl:text>: </xsl:text></td>
 								<td>
 									<input type="text" name="s1.username"/>
@@ -328,5 +358,5 @@
 							</tr>
 							<tr>
-								<td><xsl:text>Password: </xsl:text></td>
+								<td><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.password')"/><xsl:text>: </xsl:text></td>
 								<td>
 									<input id="passwordOne" type="password" name="s1.password"/>
@@ -334,5 +364,5 @@
 							</tr>
 							<tr>
-								<td><xsl:text>Retype password: </xsl:text></td>
+								<td><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.retype_password')"/><xsl:text>: </xsl:text></td>
 								<td>
 									<input id="passwordTwo" type="password"/>
@@ -340,5 +370,5 @@
 							</tr>
 							<tr>
-								<td><xsl:text>Email address: </xsl:text></td>
+								<td><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.email')"/><xsl:text>: </xsl:text></td>
 								<td>
 									<input type="text" name="s1.email"/>
@@ -347,5 +377,5 @@
 							<xsl:if test="/page/pageResponse/authenticationNode/service/@operation = 'AddUser'">
 								<tr>
-									<td><xsl:text>Groups: </xsl:text></td>
+									<td><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.groups')"/><xsl:text>: </xsl:text></td>
 									<td>
 										<input id="groupsInput" size="50" type="text" name="s1.groups"/>
@@ -359,5 +389,5 @@
 									</td>
 									<td>
-										<button id="addGroupButton">Add Group</button>
+										<button id="addGroupButton"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.add_group')"/></button>
 										<script type="text/javascript">
 											<xsl:text disable-output-escaping="yes">
@@ -386,5 +416,5 @@
 								</tr>
 								<tr>
-									<td><xsl:text>Comment: </xsl:text></td>
+									<td><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.comment')"/><xsl:text>: </xsl:text></td>
 									<td>
 										<textarea name="s1.comment" style="width:100%;"><xsl:text> </xsl:text></textarea>
@@ -392,8 +422,8 @@
 								</tr>
 								<tr>
-									<td><xsl:text>Status: </xsl:text></td>
-									<td>
-										<input type="radio" name="s1.status" value="true" checked="true"/><xsl:text>Enabled </xsl:text>
-										<input type="radio" name="s1.status" value="false"/><xsl:text>Disabled </xsl:text>
+									<td><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.status')"/><xsl:text>: </xsl:text></td>
+									<td>
+										<input type="radio" name="s1.status" value="true" checked="true"/><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.enabled')"/><xsl:text> </xsl:text>
+										<input type="radio" name="s1.status" value="false"/><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.disabled')"/><xsl:text> </xsl:text>
 									</td>
 								</tr>
@@ -418,5 +448,5 @@
 							<tr>
 								<td>
-									<input id="submitButton" type="submit" value="Submit"/>
+									<input id="submitButton" type="submit" value="{util:getInterfaceText($interface_name, /page/@lang, 'authen.submit')}"/>
 									<script type="text/javascript">
 										<xsl:text disable-output-escaping="yes">
@@ -450,8 +480,8 @@
 					<xsl:choose>
 						<xsl:when test="/page/pageResponse/error">
-							<xsl:text>Error: Failed to add user</xsl:text>
+							<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.error_failed_to_add')"/>
 						</xsl:when>
 						<xsl:otherwise>
-							<xsl:text>User added successfully</xsl:text>
+							<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.user_added_success')"/>
 							<meta http-equiv="refresh" content="2; url={/page/pageRequest/@baseURL}{$library_name}"/> 
 						</xsl:otherwise>
@@ -460,5 +490,5 @@
 				
 				<xsl:otherwise>
-					<xsl:text>Page not found.</xsl:text>
+					<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'authen.page_not_found')"/>
 				</xsl:otherwise>
 			</xsl:choose>