Index: main/trunk/greenstone3/web/WEB-INF/classes/interface_default.properties
===================================================================
--- main/trunk/greenstone3/web/WEB-INF/classes/interface_default.properties	(revision 25269)
+++ main/trunk/greenstone3/web/WEB-INF/classes/interface_default.properties	(revision 25297)
@@ -268,23 +268,24 @@
 authen.login_descibe_line_3=Please enter your Greenstone username and password.
 authen.no_permission=Sorry, you do not have permission to access this page.
-authen.username=username
+authen.username=Username
 authen.username_describe=Usernames must be between 2 and 30 characters long. They can contain alphanumeric characters, '.', and '_'.
-authen.password=password
+authen.password=Password
 authen.password_describe=Passwords must be between 3 and 8 characters long. They can contain any normal printable ASCII characters.
-authen.account_status=account status
+authen.account_status=Account status
 authen.enabled=enabled
 authen.disabled=disabled
-authen.groups=groups
+authen.groups=Groups
+authen.add_group=Add Group
 authen.groups_describe=Groups is a comma separated list.
-authen.comment=comment
-authen.email=email address
-authen.add_a_new_user_title=Add a new user
+authen.comment=Comment
+authen.email=Email address
+authen.add_a_new_user_title=Add a New User
 authen.change_password_title=Change password
 authen.change_password_login_describe_line_1=The page you have requested requires you to sign in.
 authen.change_password_login_describe_line_2=Please enter your Greenstone username and password.
 authen.change_password_describe_line_1=Passwords must be between 3 and 8 characters long. They can contain any normal printable ASCII characters.
-authen.old_password=old password
-authen.new_password=new password
-authen.retype_new_password=retype new password
+authen.old_password=Old password
+authen.new_password=New password
+authen.retype_password=Retype password
 authen.change_password_successed_title=Change password
 authen.change_password_successed_content=Your password was successfully changed.
@@ -297,5 +298,5 @@
 authen.retyped_password_invalid=The retyped password is invalid.				 
 authen.username_password_empty_warning=Either the username or the new password cannot be empty.
-authen.edit_user_information=Edit user information
+authen.edit_user_information=Edit User Information
 authen.do_you_really_want_to_permanently_remove_user=Do you really want to permanently remove user "
 authen.user_has_existed=The user name has existed in the users table, choose an unique one.
@@ -304,7 +305,7 @@
 authen.wrong_password_warning=Either your username or password was incorrect.
 authen.list_of_current_users_title=List of current users
-authen.delete_warning=Do you really want to permanently remove user "
-authen.edit=edit
-authen.delete=delete
+authen.delete_warning=Are you sure you want to delete user 
+authen.edit=Edit
+authen.delete=Delete
 authen.sign_in=sign in
 authen.account_status_false=The account is disabled, request Administrator for more information.
@@ -317,2 +318,52 @@
 authen.login=login
 authen.login_successfully=Login successful
+authen.register=Register
+authen.account_settings=Account Settings
+authen.change_password=Change Password
+authen.reset_password=Reset Password
+authen.status=Status
+authen.submit=Submit
+authen.error_failed_to_add=Error: Failed to add user
+authen.user_added_success=User added successfully
+authen.page_not_found=Page not found
+
+###################
+# Document basket #
+###################
+db.doc_basket=Document basket
+
+#############################
+# Document structure editor #
+#############################
+dse.no_docs=No documents in the Document Basket
+dse.untitled=UNTITLED DOCUMENT
+dse.delete_section=delete section
+dse.edit=edit
+dse.hide=hide
+dse.add_sub_section=add sub-section
+dse.duplicate=duplicate
+dse.error_saving=There was an error saving, aborting
+dse.save_changes=Save changes
+dse.saving=Saving
+dse.modifying_archives=Modifying archive files
+dse.empty_collection_list=List of collections to build is empty
+dse.could_not_build_p1=Could not build collection
+dse.could_not_build_p2=, aborting the building operation
+dse.could_not_activate_p1=Could not activate collection
+dse.could_not_activate_p2=, aborting the activation operation
+dse.activating=Activating collection
+dse.building=Building collection
+dse.could_not_check_status_p1=Could not check status of
+dse.could_not_check_status_p2a=, there was an error in the XML, aborting the operation
+dse.could_not_check_status_p2b=, there was an error on the server, aborting the operation
+dse.error_saving_changes=There was an error saving your changes
+dse.error_code=Error Code
+dse.error_reason=Error Reason
+dse.error_line=Error Line
+dse.xml_error=There was an error parsing the XML
+dse.browse_cannot_validate_xml=Your browser cannot handle XML validation
+dse.add_new_metadata=Add new metadata
+dse.no_value_given=No value given for new metadata name
+dse.create_new_document=Create new document
+dse.untitled_section=UNTITLED SECTION
+dse.insert_new_section=Insert new section